% Example5_1.m
% Calculation of DFT of an N-point sequence and
% comparing with the DTFT of the same sequence
% Author: K.S. Thyagarajan
%
clear
N = 32; % sequence length
M = 32; % length of DFT
M1 = M/2;
n = 0:N-1;
x = (0.5).^n;% N-point sequence
X = fft(x,M); % DFT of the N-point sequence
A = zeros(size(x)); A(1) = 1;
%[H,W] = freqz(x,A,M);% DTFT of the N-point sequence
[H,W] = freqz(x,A,M,'whole');
figure,plot(W,abs(H)),hold on
%stem((pi/M1)*(0:M1-1),abs(X(1:M1)),'k'), hold off
stem((2*pi/M)*(0:M-1),abs(X),'k'), hold off
title(['DTFT & DFT of a ' int2str(N) '-point sequence'])
ylabel('Magnitude'), xlabel('Normalized frequency')
legend('DTFT', 'DFT')
%
figure,plot(W,angle(H)/pi*180),hold on
%stem((pi/M1)*(0:M1-1),angle(X(1:M1))/pi*180,'k'), hold off
stem((2*pi/M)*(0:M-1),angle(X)/pi*180,'k'), hold off
title(['DTFT & DFT of a ' int2str(N) '-point sequence'])
ylabel('Phase(deg)'), xlabel('Normalized frequency')
legend('DTFT', 'DFT')