% Example5_8.m
% Demonstrates the effect of leakage of the energy 
% into DFT bins k*fs/N 
% if f*N/fs is not equal to an integer,
% then DFT leakage occurs
clear
N = 64; % number of points of DFT
f = 10; % frequency of input sinusoid
fs = f*N/4.5; % sampling frequency not an integer multiple of N
M = 4;
fs1 = f*N/M; % sampling frequency which is M x N
w = 2*pi*f/fs;
w1 = 2*pi*f/fs1;
n = 0:N-1;
x = sin(w*n);
x1 = sin(w1*n);
figure,subplot(2,1,1),stem(n,x,'k')
title(['Input signal sampled at ' num2str(fs) ' Hz'])
ylabel('Amplitude')
subplot(2,1,2),stem(n,x1,'k')
title(['Input signal sampled at ' num2str(fs1) ' Hz'])
ylabel('Amplitude'), xlabel('Sample index, n')
X = fft(x);
X1 = fft(x1);
figure,subplot(2,1,1),stem((fs/N)*n,abs(X)/max(abs(X)),'k')
title(['DFT of input signal sampled at ' num2str(fs) ' Hz'])
ylabel('Normalized magnitude')
subplot(2,1,2),stem((fs1/N)*n,abs(X1)/max(abs(X1)),'k')
title(['DFT of input signal sampled at ' num2str(fs1) ' Hz'])
ylabel('Normalized magnitude')
xlabel('DFT bins, Hz')
%
%wind = kaiser(N,3.25);
Y = fft(x.* (window(@kaiser,N,3.75))');
figure,subplot(2,1,1),stem((fs/N)*n,abs(X)/max(abs(X)),'k')
title(['DFT of input signal sampled at ' num2str(fs) ' Hz'])
ylabel('Normalized magnitude')
subplot(2,1,2),stem((fs/N)*n,abs(Y)/max(abs(Y)),'k')
title('DFT of input signal using Kaiser window')
ylabel('Normalized magnitude')
xlabel('DFT bins, Hz')