% Verify_Parseval.m
% Verifies Parseval's theorem
% Author: K.S. Thyagarajan
%
% sum(|x[n=0:N-1]|^2)=(1/N)sum(|X[k=0:N-1]|^2
clear
n = 0:31;
x = (0.85.^n).*exp(1i*0.35.*n);% complex sequence
E1 = sum(abs(x).^2);% energy in time domain
X = fft(x);
E2 = sum(X.*conj(X))/length(n);%energy in freq. domain
sprintf('Energy in time = %d\nEnergy in freq.= %d', E1,E2)